SuperStrict
Framework brl.basic
Import brl.max2d
Import brl.glmax2d
Import brl.retro
Import brl.font
AppTitle$ = "Flappy Controls"
Graphics 640, 480, 0, 50
SetBlend(ALPHABLEND)
SeedRnd(MilliSecs())
Global BarrierList:TList = New TList
Type tBarrier
	Field top:Byte
	Field height%
	Field x#
End Type

Global HighscoreList:TList = New TList
Type tHighscore
	Field score%
	Field name$
End Type

Const maxSpeedY# = 280.0
Const minBarrierLen% = 40
Const BarrierWidth% = 40
Const StartSpeedX# = 36.0
Global playerY#, playerDistance#, playerMoveY#, speedX#
Global mx%, my%, gameState:Byte = 0
Global loopstart%, loopend%, lastgameend%, lastgamescore%
Global playerName$ = "Player"
MoveMouse(GraphicsWidth() / 2, GraphicsHeight() / 2)
mx = MouseX() ; my = MouseY()
HideMouse()
LoadHighscore()

Repeat
	loopstart = MilliSecs()
	Cls
	If gameState = 1
		speedX = StartSpeedX + playerDistance * 0.008
		playerMoveY = playerMoveY + Sqr(Abs(mx - MouseX()) * Abs(mx - MouseX()) + Abs(my - MouseY()) * Abs(my - MouseY()))
		If playerMoveY > maxSpeedY
			playerMoveY = maxSpeedY
		Endif
		SetColor(64, 255, 64)
		DrawOval(40, playerY, 40, 40)
		playerY = playerY - ms(playerMoveY)
		playerDistance = playerDistance + ms(speedX)
		
		If playerMoveY > 0
			playerMoveY = playerMoveY * 0.8
		EndIf
		playerMoveY = playerMoveY + ms(-50)
		If playerMoveY < - maxSpeedY
			playerMoveY = -maxSpeedY
		Endif
		
		SetColor(255, 64, 64)
		For Local b:tBarrier = EachIn BarrierList
			Local barrierHeight% = (2 * b.top - 1) * b.height
			If(barrierHeight > 0)
				DrawRect(b.x - playerDistance, 0, BarrierWidth, barrierHeight)
				If RectCollide(40, playerY, 40, 40, b.x - playerDistance, 0, BarrierWidth, barrierHeight)
					GameOver()
				EndIf
			Else
				DrawRect(b.x - playerDistance, GraphicsHeight() + barrierHeight, BarrierWidth, Abs(barrierHeight))
				If RectCollide(40, playerY, 40, 40, b.x - playerDistance, GraphicsHeight() + barrierHeight, BarrierWidth, Abs(barrierHeight))
					GameOver()
				EndIf
			EndIf
			If b.x - playerDistance + BarrierWidth < 0
				BarrierList.Remove(b)
			Endif
		Next
		If BarrierList.Count() < playerDistance * 0.01
			Local bothSides% = Rand(0, playerDistance * 0.01)
			If bothSides > 50
				For Local i% = 0 To 1
					Local newBarrier:tBarrier = New tBarrier
					newBarrier.top = i
					newBarrier.height = Rand(minBarrierLen, minBarrierLen * 4 + playerDistance * 0.01)
					If newBarrier.height > GraphicsHeight() / 2 - 50
						newBarrier.height = GraphicsHeight() / 2 - 50
					Endif
					newBarrier.x = playerDistance + 40 + GraphicsWidth()
					BarrierList.AddLast(newBarrier)
				Next
			Else
				Local newBarrier:tBarrier = New tBarrier
				newBarrier.top = Rand(0, 1)
				newBarrier.height = Rand(minBarrierLen, minBarrierLen * 4 + playerDistance * 0.01)
				If newBarrier.height > GraphicsHeight() / 2 - 20
					newBarrier.height = GraphicsHeight() / 2 - 20
				Endif
				newBarrier.x = playerDistance + 40 + GraphicsWidth()
				BarrierList.AddLast(newBarrier)
			Endif
		Endif
		If playerY < 0 Or playerY + 40 > GraphicsHeight()
			GameOver()
		Endif
		SetColor(255, 255, 255)
		DrawText("Score: " + Int(playerDistance / 10), GraphicsWidth() / 2 - TextWidth("Score: " + Int(playerDistance / 10)) / 2, 12)	
	Else
		If Sqr(Abs(mx - MouseX()) * Abs(mx - MouseX()) + Abs(my - MouseY()) * Abs(my - MouseY())) > 35 And MilliSecs() > lastgameend + 1000
			gameState = 1
			mx = MouseX() ; my = MouseY()
			MoveMouse(GraphicsWidth() / 2, GraphicsHeight() / 2)
			InitBarriers()
			playerDistance = 0
			playerY = GraphicsHeight() / 2
			playerMoveY = 0.0
			Continue
		EndIf
		SetColor(255, 255, 255)
		DrawText("Enter your name: " + playerName, GraphicsWidth() / 2 - TextWidth("Enter your name: " + playerName) / 2, 24)
		For Local i% = KEY_0 To KEY_Z
			If KeyHit(i)
				If playerName = "Player"
					playerName = ""
				Endif
				If KeyDown(KEY_LSHIFT)
					playerName = playerName + Chr(i)
				Else
					playerName = playerName + Lower(Chr(i))
				EndIf
			Endif
		Next
		If KeyHit(KEY_SPACE)
			playerName = playerName + Chr(KEY_SPACE)
		ElseIf KeyHit(KEY_BACKSPACE)
			If playerName.Length > 0
				playerName = Left(playerName, playerName.Length - 1)
			Endif
		EndIf
		If lastgamescore > 0
			SetColor(25, 185, 25)
			DrawText("Your last score: " + lastgamescore, GraphicsWidth() / 2 - TextWidth("Your last score: " + lastgamescore) / 2, 50)
		Endif
		SetColor(200, 25, 25)
		DrawText("Move the mouse rapidly to start playing", GraphicsWidth() / 2 - TextWidth("Move the mouse rapidly to start playing") / 2, 74)
		SetColor(128, 128, 128)
		DrawText("Highscore", GraphicsWidth() / 2 - TextWidth("Highscore") / 2, 128)
		Local hsI%
		For Local hs:tHighscore = EachIn HighscoreList
			SetColor(255 * (hsI / 20.0), 255 * ((20 - hsI) / 20.0), 0)
			DrawText(hs.name, GraphicsWidth() / 2 - TextWidth(hs.name) / 2, 128 + (hsI + 1) * GetImageFont().Height())
			DrawText(hs.score, GraphicsWidth() / 2 - TextWidth(hs.score) / 2, 128 + (hsI + 2) * GetImageFont().Height())
			hsI = hsI + 2
		Next
	EndIf
	mx = MouseX() ; my = MouseY()
	MoveMouse(GraphicsWidth() / 2, GraphicsHeight() / 2)
	
	Flip 0
	If MilliSecs() - loopstart < 20
		Delay 20 - (MilliSecs() - loopstart)
	Endif
	loopend = MilliSecs() - loopstart
Until AppTerminate() Or KeyHit(KEY_ESCAPE)

Function GameOver()
	gameState = 0
	lastgameend = MilliSecs()
	Local link:TLink = HighscoreList.FirstLink()
	For Local hs:tHighscore = EachIn HighscoreList
		If Int(playerDistance / 10) > hs.score
			Local newHs:tHighscore = New tHighscore
			newHs.name = playerName
			newHs.score = Int(playerDistance / 10)
			HighscoreList.InsertBeforeLink(newHs, link)
			HighscoreList.RemoveLast()
			SaveHighscore()
			Exit
		Endif
		link = link.NextLink()
	Next
	lastgamescore = Int(playerDistance / 10)
End Function

Function SaveHighscore()
	Local file:TStream = WriteStream("highscore.hs")
	For Local hs:tHighscore = EachIn HighscoreList
		file.WriteLine(hs.name)
		file.WriteLine(hs.score)
	Next
	file.Close()
End Function

Function LoadHighscore()
	Local file:TStream = ReadStream("highscore.hs")
	Repeat
		Local newHs:tHighscore = New tHighscore
		newHs.name = file.ReadLine()
		newHs.score = Int(file.ReadLine())
		HighscoreList.AddLast(newHs)
	Until file.Eof()
	file.Close()
End Function

Function InitBarriers()
	BarrierList.Clear()
	For Local i% = 0 To 10
		Local newBarrier:tBarrier = New tBarrier
		newBarrier.top = Rand(0, 1)
		newBarrier.height = Rand(minBarrierLen, minBarrierLen * 4)
		newBarrier.x = 120 + (1 + i * 1.2) * BarrierWidth * 2
		BarrierList.AddLast(newBarrier)
	Next
End Function

Function ms#(in#, factor# = 0.002)
    return (in*loopend)*factor;
End Function

Function RectCollide%(x1%, y1%, w1%, h1%, x2%, y2%, w2%, h2%)
	If (x1 + w1) > x2
		If (y1 + h1) > y2
			If x1 < (w2 + x2) And y1 < (h2 + y2)
				Return 1
			EndIf
		EndIf
	EndIf
End Function
